#include <iostream>
#include <fstream>
#include <sys/time.h>
#include <ctime>
#include <string>
#include <stdlib.h>

#include "algo.h"

using namespace std;

Algo::Algo() {
	s = 0;	//pocet porovnani
	m = 0;  //velkost poli
}

Algo::~Algo() {
}

int Algo::Nacitaj(char* file) {
	int index, real_l;
	char* buff;
	wchar_t* wbuff;
	ifstream input;
	
	buff = new char[BUF_LEN + 5];
	wbuff = new wchar_t[BUF_LEN + 5];

	if (!input.is_open()) input.open(file);

	if (!input.is_open()){
		cerr << "not open" << endl;
		return 1;
	}

//	input >> l_pattern >> l_text;
	input.getline(buff,BUF_LEN);
	sscanf(buff,"%ld %ld", &l_pattern, &l_text);
	cerr << l_pattern << " " << l_text << endl;
	pattern = new wchar_t[l_pattern+1];
	text = new wchar_t[l_text+1];
	
	// zahadzovaci read
	index = 0;
	for(int i = 0; i < l_pattern; i+= real_l) {
		input.get(buff, BUF_LEN);
		real_l = mbstowcs(wbuff, buff, BUF_LEN);
		for (int j = 0; j <= real_l; j++) {
			pattern[index] = wbuff[j];
			index++;
		}
		index--;
	}
	
	input.get();
	index=0;
	for(int i = 0; i < l_text; i += real_l){
		input.get(buff, BUF_LEN);
		real_l = mbstowcs(wbuff, buff, BUF_LEN);
		for (int j = 0; j <= real_l; j++){
			 text[index] = wbuff[j];
			 index++;
		}
		index--;
	}

	delete[] buff;
	delete[] wbuff;

	input.close();
	if (input.is_open()) cerr << "Error closing input file" << endl;
	
	return 0;
}

int Algo::Vypis(){
	cout << pattern << endl;
	cout << text << endl;

	return 0;
}

int Algo::Vypis_zlozitost(){
	cout << "Porovnania: " << s << endl;
	cout << "Pamet: " << m << endl;
	trvanie = (kon.tv_usec - zac.tv_usec) + 10000*(kon.tv_sec - zac.tv_sec);
	cout << "Cas: " << trvanie << endl;
	cout << "*************************" << endl;
	return 0;
}

bool Algo::STEP(){
	s++;
	return true;
}

void Algo::MEM_INC(){
	m++;
}

void Algo::MEM_DEC(){
	m--;
}
