#include <iostream>
#include "algo.h"
#include "good_suffix.h"
#include "bad_character.h"
#include "ap_gia_bm.h"

using namespace std;

int Ap_Gia_BM::Match(){
	int *Lbox, *lbox, *Rbox, *Mbox, *Nbox, k, count = 0;
	bool END;

	gettimeofday(&zac, &tz);
	
	Nbox = Nvalues();
	
	Lbox = Lvalues();

	lbox = lvalues();

	Rbox = Rvalues();

	Mbox = new int[l_text];			// -1: undefined, Mbox[i]: dlzka podstringu T, ktory je suffix P a konci na i
	for (int i = 0; i < l_text; i++){
		Mbox[i] = -1;
		MEM_INC();
	}

	k = (l_pattern - 1);
	while (k < l_text){
//		cerr << "k: " << k << endl;
//
		int j = k;
//		cerr << k << " " << (char)text[k] << " " << (char)text[k-1] << endl;
		int i = l_pattern - 1;

//		phase algorithm: snazi sa vyhnut explicitnym porovnavaniam
		
		END = false;
		while (!END) {
		
		if ((Mbox[j] < 0) || ((Mbox[j] == Nbox[i]) && (Nbox[i] == 0))){
			if (STEP() && (text[j] == pattern[i]) && (i >= 0)){
					j--;
					i--;
					if (i < 0) {
						count++;
						Mbox[k] = l_pattern;
//						cerr << "Mbox[" << k << "]: " << Mbox[k] << endl;
						END = true;
					}
			}
			else if (text[j] != pattern[i]){
					Mbox[k] = k-j;
//					if (k == 187) cerr << "Mbox[" << k << "]: " << Mbox[k] << " " << j << " " << text[j] << " " <<pattern[i] << " " << i << endl;
					END = true;
			}
		}
		else if (Mbox[j] < Nbox[i]){
			if (Mbox[j] == 0){
				END = true;
//			cerr << "Mbox[" << j << "]:"<< Mbox[j] << endl;
			}
			else {
			      i -= Mbox[j];
			      j -= Mbox[j];
			}
		}
		else if ((Mbox[j] >= Nbox[i]) && (Nbox[i] == i+1)){
			count++;
			Mbox[k] = k-j;
//			if (k == 187) cerr << "Mbox[" << k << "]: " << Mbox[k] << " " << j <<  endl;
			i = -1;			//aby B_M shiftol, ako ked je najdeny vyskyt pattern konciaci na k
			END = true;
		}
		else if ((Mbox[j] > Nbox[i]) && (Nbox[i] < i+1)){
			Mbox[k] = k-j;
			i -= Nbox[i];		//skutocny mismatch na tychto poziciach
			j -= Nbox[i];
			END = true;
		}
		else if ((Mbox[j] == Nbox[i]) && (0 < Nbox[i]) && (Nbox[i] < i+1)){
			i -= Mbox[j];
			j -= Mbox[j];
		}
		} //koniec phase algorithm	
		
		//shifty podla B-M
		
		if (i < 0)				//vyskyt pattern
			k += (l_pattern - lbox[1]);
		else {	
			int jj = (int) text[j], bc, gs;		//bc: bad character, gs: good suffix
			
//			text[j] < 'a' ? jj -= 65 : jj -= 71;
			1 > (i - Rbox[jj]) ? bc = 1 : bc = (i - Rbox[jj]);
//			if (k == 192) cerr << bc << " ";

			if (i == l_pattern - 1)		//mismatch na poslednom znaku pattern
				gs = 1;
			else if (Lbox[i + 1] > 0)
				gs = (l_pattern - Lbox[i+1] - 1);
			else gs = (l_pattern - lbox[i+1] - 1);
//			if (k == 192) cerr << gs << endl;

//			cerr << "bc: " << bc << " gs: " << gs << endl;
			bc > gs ? k += bc : k += gs;	//pouzije to, ktore shiftne o viac
		}
	}

	gettimeofday(&kon, &tz);

	delete[] Rbox;
	delete[] Lbox;
	delete[] lbox;
	delete[] Mbox; 
	
	return count;
}
