#include <iostream>
#include <sys/time.h>
#include "algo.h"
#include "good_suffix.h"
#include "bad_character.h"

using namespace std;

int* Bad_character::Rvalues(){		//R[x]: najpravejsi vyskyt znaku x v P, alebo 0, ak sa nevyskytuje
	int *Rbox;

//	Rbox = new int[52];  //male a velke pismena anglickej abecedy
	Rbox = new int[65536];  //unicode

//	for (int i = 0; i < 52; i++){
	for (int i = 0; i < 65536; i++){
		MEM_INC();
		Rbox[i] = 0;
	}
	for (int i = l_pattern-1; i >= 0; i--){
		wchar_t j = pattern[i];
		int jj = (int) j;
		//zmenit na ? operator?
//		(j < 'a') ? if (Rbox[jj - 65] == 0) Rbox[jj - 65] = i : if (Rbox[jj - 71] == 0) Rbox[jj - 71] = i;
		
		if (Rbox[jj] == 0) Rbox[jj] = i;

	}
	return Rbox;
}
	
int Bad_character::Match(){
	int *Rbox, count = 0;

	gettimeofday(&zac, &tz);
	
	Rbox = Rvalues();
	
	int k = (l_pattern - 1);
	while (k < l_text){
//		cerr << "k: " << k << endl;
		int j = k;
		int i = (l_pattern - 1);
		while (STEP() && (text[j] == pattern[i]) && (i>= 0)){
			j--;
			i--;
		}
		if (i < 0){ 
			count++;
			k += 1;
		}
		else {  
			int jj = (int) text[k];
//			text[j] < 'a' ? jj -= 65 : jj -= 71;
			1 > (i - Rbox[jj]) ? k += 1 : k += (i - Rbox[jj]);
			
		}
	}

	gettimeofday(&kon, &tz);
	
	return count;
}
