#include <iostream>
#include "algo.h"
#include "good_suffix.h"
#include "bad_character.h"
#include "boyer_moore.h"

using namespace std;

int Boyer_Moore::Match(){		//kombinuje bad_wchar_tacter a good_suffix, posunie P o co najviac
	int *Lbox, *lbox, *Rbox, k,count = 0, lpnt = -1, rpnt = -1;
	bool galil = 0;

	gettimeofday(&zac, &tz);
	
	Lbox = Lvalues();

	lbox = lvalues();

	Rbox = Rvalues();

	k = (l_pattern - 1);
	while (k < l_text){
//		cerr << "k: " << k << endl;
		int j = k;
		int i = l_pattern - 1;
		while (STEP() && (text[j] == pattern[i]) && (j > rpnt) && (i >= 0)){
				j--;
				i--;
		}
		if ((i < 0) || ((galil) && (j == rpnt))){
			count++;
			rpnt = k;
//			cerr << "ha" << endl;
			if (galil) lpnt = k - l_pattern + 1;
			else lpnt = j;
			k += (l_pattern - lbox[1]);
			if ((k - l_pattern + 1) > lpnt){
				galil = true;
			}	
			else {
				galil = false;
				rpnt = -1;
			}
		}
		else {
			int jj = (int) text[j], bc, gs;
			
			lpnt = j;
			rpnt = k;	
//			text[j] < 'a' ? jj -= 65 : jj -= 71; 
			1 > (i - Rbox[jj]) ? bc = 1 : bc = (i - Rbox[jj]);

			if (i == l_pattern - 1)		//mismatch na poslednom znaku pattern
				gs = 1;
			else if (Lbox[i + 1] > 0)
				gs = (l_pattern - Lbox[i+1] - 1);
			else gs = (l_pattern - lbox[i+1]);

//			cerr << "bc: " << bc << " gs: " << gs << endl;
			bc >= gs ? k += bc : k += gs;

			if ((k - l_pattern + 1) > lpnt){
				galil = true;
			}	
			else {
				galil = false;
				rpnt = -1;
			}
		}
	}

	gettimeofday(&kon, &tz);

	delete[] Lbox;
	delete[] lbox;
	delete[] Rbox;
	
	return count;
}
