#include <iostream>
#include <sys/time.h>
#include <list>
#include "algo.h"
#include "good_suffix.h"
#include "bad_character.h"
#include "extended_bc.h"

using namespace std;

list<int> *Extended_bc::Rvalues(){
	  list<int> *Rbox;
	  int cc;

//	  Rbox = new list<int>[52];
	  Rbox = new list<int>[65536];

//	  for (int i=0; i < 52; i++){
	  for (int i=0; i < 65536; i++){
		MEM_INC(); 
		list<int> L;
		Rbox[i] = L; 
	  }

	  for (int index = l_pattern -1; index >=0; index--){
		  wchar_t c = pattern[index];
//		  'c' < 'a' ? cc = (int) c - 65 : cc = (int) c - 71;
		  cc = (int) c;
		  Rbox[cc].push_back(index);
	  }

	  return Rbox;
}


int Extended_bc::Match(){
	list<int>* Rbox;
	int count = 0, cc;

	gettimeofday(&zac,&tz);

	Rbox = Rvalues();

	list<int>::iterator iter;
	
	int k = (l_pattern - 1);
	while (k < l_text){
//		cerr << "k: " << k << endl;
		int j = k;
		int i = (l_pattern - 1);
		while (STEP() && (text[j] == pattern[i]) && (i>= 0)){
			j--;
			i--;
		}
		if (i < 0){ 
			count++;
			k += 1;
		}
		else { 
			wchar_t c = text[j];
		  	 cc = (int) c;
			iter = Rbox[cc].begin();
			while ((iter != Rbox[cc].end()) && (*iter > i )) iter++;
			if (iter != Rbox[cc].end()) k += (i - *iter); 
			else k++;
		}
	}
	gettimeofday(&kon, &tz);
	
	return count;
}
